import sqlalchemy as sa
import sqlalchemy.exceptions
import logging

logging.getLogger("sqlalchemy.pool").setLevel(logging.DEBUG)

from twisted.internet import reactor

mysql_engine = sa.create_engine("mysql://localhost/bench")
mysql_engine.connection_provider._pool._timeout = 0
sleep_time = 3

max_try = 5 # > pool_size + overflow (defaulting to -5 in SA)
retries = 0
def do_stuff(num_try=0):
	logging.warning("I'm doing stuff")
	
	def simple_select(thetry):
		logging.warning("in simple select for try %d" % thetry)
		mysql_engine.execute("select 1").fetchall()
		logging.warning("OK, I've done stuff")
	
	def do_retry():
		global retries
		logging.warning("in do_retry")
		if retries <= max_try:
			if num_try == retries:
				retries += 1
			logging.warning("retry in 2s")
			reactor.callLater(sleep_time,do_stuff,retries)
			
	try:
		simple_select(num_try)
	except (sqlalchemy.exceptions.DBAPIError,sqlalchemy.exceptions.TimeoutError), e:
		logging.warning("raise '%s'" % e)
		if num_try == max_try:
			logging.warning("reached max try")
			raise
		else:
			#################################
			#
			# Choose whether you want to clean the pool
			#
			#################################
			
			# In this 'if', clean the pool
			#if isinstance(e,sqlalchemy.exceptions.TimeoutError):
			#	mysql_engine.connection_provider.dispose()
			#	logging.warning("!!!!!!!!!!!! cleaned pool. overflow is now %d" % mysql_engine.connection_provider._pool.overflow())
			#	pass
			
			# In this one, do nothing
			if isinstance(e,sqlalchemy.exceptions.TimeoutError):
				pass

			do_retry()
		

def do_repeat_stuff():
	for i in range(30):
		logging.warning("calling do_stuff, i=%d" % i)
		do_stuff()


logging.warning("Starting reactor in 1s")
reactor.callLater(1,do_repeat_stuff)
reactor.run()
